Subject: Re: [PATCH bpf-next V1] bpf: devmap dynamic map-value area based on BTF

From: David Ahern <[email-masked]>
Date: Thu, 4 Jun 2020 10:40:06 -0600

On 6/4/20 9:48 AM, Jesper Dangaard Brouer wrote:
> I will NOT send a patch that expose this in uapi/bpf.h.  As I explained
> before, this caused the issues for my userspace application, that
> automatically picked-up struct bpf_devmap_val, and started to fail
> (with no code changes), because it needed minus-1 as input.  I fear
> that this will cause more work for me later, when I have to helpout and
> support end-users on e.g. xdp-newbies list, as it will not be obvious
> to end-users why their programs map-insert start to fail.  I have given
> up, so I will not NACK anyone sending such a patch.
> 
> Why is it we need to support file-descriptor zero as a valid
> file-descriptor for a bpf-prog?

That was a nice property of using the id instead of fd. And the init to
-1 is not unique to this; adopters of the bpf_set_link_xdp_fd_opts for
example have to do the same.